(ns integration.jobtech-taxonomy.api.db.graphviz-test
  (:require [clojure.test :as test :refer [deftest is testing]]
            [jobtech-taxonomy.api.db.graphviz :as gv]
            [taoensso.timbre :as log]
            [utils.db-fixtures :as udf]))

(test/use-fixtures :each
  (fn [fun-run]
    (log/with-merged-config
      {:min-level [[#{"io.methvin.watcher.*"} :info]
                   [#{"datahike.*"} :info]
                   [#{"jobtech-taxonomy.api.db.database-connection"} :warn]
                   [#{"*"} :info]]}
      (fun-run)))
  (udf/database-minimal udf/cfg))

(deftest test-weird-fn
  (testing "not bi-directional"
    (is (= {:from "a"
            :relations #{"related" "narrow_match"}
            :bi-directional false
            :to "b"}
           (gv/weird-fn
            [{:from "a"
              :relations #{"related" "narrow-match"}
              :to "b"}]))))
  (testing "bi-directional"
    (is (= {:from "a"
            :relations #{"related"}
            :bi-directional true
            :to "b"}
           (gv/weird-fn
            [{:from "a"
              :relations #{"related"}
              :to "b"}])))))

(deftest test-edge-query
  (let [types-for-version (gv/edge-query udf/cfg :latest)]
    (testing "test types-for-version"
      (is (= (frequencies [{:from "occupation-name", :relations #{"broad-match" "broader"}, :to "isco-level-4"}
                           {:from "occupation-name", :relations #{"broader"}, :to "ssyk-level-4"}
                           {:from "ssyk-level-4", :relations #{"broader"}, :to "occupation-field"}
                           {:from "ssyk-level-4", :relations #{"broad-match"}, :to "skill"}])
             (frequencies types-for-version))))))

(deftest test-edges-for-version
  (let [types-for-version (gv/edges-for-version udf/cfg :latest)]
    (testing "test types-for-version"
      (is (= (frequencies [{:from "occupation-name", :relations #{"broad_match" "broader"}, :bi-directional false, :to "isco-level-4"}
                           {:from "occupation-name", :relations #{"broader"}, :bi-directional false, :to "ssyk-level-4"}
                           {:from "ssyk-level-4", :relations #{"broader"}, :bi-directional false, :to "occupation-field"}
                           {:from "ssyk-level-4", :relations #{"broad_match"}, :bi-directional false, :to "skill"}])
             (frequencies types-for-version))))))

#_(deftest test-types-svg
    (let [types-map (gv/types-svg udf/cfg {:version :latest})]
      (testing "test types-map"
        (is (= "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n<!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\"\n \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\">\n<!-- Generated by graphviz version 2.42.4 (0)\n -->\n<!-- Title: TaxonomyTypes Pages: 1 -->\n<svg width=\"554pt\" height=\"146pt\"\n viewBox=\"0.00 0.00 554.00 145.50\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\">\n<g id=\"graph0\" class=\"graph\" transform=\"scale(1 1) rotate(0) translate(4 141.5)\">\n<title>TaxonomyTypes</title>\n<polygon fill=\"white\" stroke=\"transparent\" points=\"-4,4 -4,-141.5 550,-141.5 550,4 -4,4\"/>\n<text text-anchor=\"middle\" x=\"273\" y=\"-109.5\" font-family=\"Arial\" font-size=\"30.00\" fill=\"#00005a\">Taxonomy Types and Relations</text>\n<!-- occupation&#45;name -->\n<g id=\"node1\" class=\"node\">\n<title>occupation&#45;name</title>\n<path fill=\"#92eb42\" stroke=\"#92eb42\" d=\"M538.33,-64C538.33,-64 434.67,-64 434.67,-64 430.83,-64 427,-60.17 427,-56.33 427,-56.33 427,-48.67 427,-48.67 427,-44.83 430.83,-41 434.67,-41 434.67,-41 538.33,-41 538.33,-41 542.17,-41 546,-44.83 546,-48.67 546,-48.67 546,-56.33 546,-56.33 546,-60.17 542.17,-64 538.33,-64\"/>\n<text text-anchor=\"middle\" x=\"486.5\" y=\"-48.8\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">occupation&#45;name</text>\n</g>\n<!-- isco&#45;level&#45;4 -->\n<g id=\"node2\" class=\"node\">\n<title>isco&#45;level&#45;4</title>\n<path fill=\"#92eb42\" stroke=\"#92eb42\" d=\"M301.83,-84C301.83,-84 234.17,-84 234.17,-84 230.33,-84 226.5,-80.17 226.5,-76.33 226.5,-76.33 226.5,-68.67 226.5,-68.67 226.5,-64.83 230.33,-61 234.17,-61 234.17,-61 301.83,-61 301.83,-61 305.67,-61 309.5,-64.83 309.5,-68.67 309.5,-68.67 309.5,-76.33 309.5,-76.33 309.5,-80.17 305.67,-84 301.83,-84\"/>\n<text text-anchor=\"middle\" x=\"268\" y=\"-68.8\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">isco&#45;level&#45;4</text>\n</g>\n<!-- occupation&#45;name&#45;&gt;isco&#45;level&#45;4 -->\n<g id=\"edge1\" class=\"edge\">\n<title>occupation&#45;name&#45;&gt;isco&#45;level&#45;4</title>\n<path fill=\"none\" stroke=\"#00005a\" d=\"M426.91,-57.91C393.46,-61 351.94,-64.84 319.87,-67.8\"/>\n<polygon fill=\"#00005a\" stroke=\"#00005a\" points=\"319.45,-64.32 309.81,-68.73 320.09,-71.3 319.45,-64.32\"/>\n<text text-anchor=\"middle\" x=\"369\" y=\"-85.3\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">broad_match</text>\n<text text-anchor=\"middle\" x=\"369\" y=\"-70.3\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">broader</text>\n<polyline fill=\"none\" stroke=\"#00005a\" points=\"409,-66.5 329,-66.5 367.22,-63.43 \"/>\n</g>\n<!-- ssyk&#45;level&#45;4 -->\n<g id=\"node3\" class=\"node\">\n<title>ssyk&#45;level&#45;4</title>\n<path fill=\"#92eb42\" stroke=\"#92eb42\" d=\"M303.33,-43C303.33,-43 232.67,-43 232.67,-43 228.83,-43 225,-39.17 225,-35.33 225,-35.33 225,-27.67 225,-27.67 225,-23.83 228.83,-20 232.67,-20 232.67,-20 303.33,-20 303.33,-20 307.17,-20 311,-23.83 311,-27.67 311,-27.67 311,-35.33 311,-35.33 311,-39.17 307.17,-43 303.33,-43\"/>\n<text text-anchor=\"middle\" x=\"268\" y=\"-27.8\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">ssyk&#45;level&#45;4</text>\n</g>\n<!-- occupation&#45;name&#45;&gt;ssyk&#45;level&#45;4 -->\n<g id=\"edge2\" class=\"edge\">\n<title>occupation&#45;name&#45;&gt;ssyk&#45;level&#45;4</title>\n<path fill=\"none\" stroke=\"#00005a\" d=\"M426.68,-42.72C420.72,-41.89 414.75,-41.13 409,-40.5 380.04,-37.3 347.58,-35.13 321.21,-33.72\"/>\n<polygon fill=\"#00005a\" stroke=\"#00005a\" points=\"321.22,-30.22 311.05,-33.2 320.86,-37.21 321.22,-30.22\"/>\n<text text-anchor=\"middle\" x=\"369\" y=\"-44.3\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">broader</text>\n<polyline fill=\"none\" stroke=\"#00005a\" points=\"392.5,-40.5 345.5,-40.5 370.14,-36.9 \"/>\n</g>\n<!-- occupation&#45;field -->\n<g id=\"node4\" class=\"node\">\n<title>occupation&#45;field</title>\n<path fill=\"#92eb42\" stroke=\"#92eb42\" d=\"M101.33,-64C101.33,-64 7.67,-64 7.67,-64 3.83,-64 0,-60.17 0,-56.33 0,-56.33 0,-48.67 0,-48.67 0,-44.83 3.83,-41 7.67,-41 7.67,-41 101.33,-41 101.33,-41 105.17,-41 109,-44.83 109,-48.67 109,-48.67 109,-56.33 109,-56.33 109,-60.17 105.17,-64 101.33,-64\"/>\n<text text-anchor=\"middle\" x=\"54.5\" y=\"-48.8\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">occupation&#45;field</text>\n</g>\n<!-- ssyk&#45;level&#45;4&#45;&gt;occupation&#45;field -->\n<g id=\"edge3\" class=\"edge\">\n<title>ssyk&#45;level&#45;4&#45;&gt;occupation&#45;field</title>\n<path fill=\"none\" stroke=\"#00005a\" d=\"M224.96,-35.67C194.83,-38.67 153.69,-42.75 119.5,-46.15\"/>\n<polygon fill=\"#00005a\" stroke=\"#00005a\" points=\"118.73,-42.7 109.13,-47.18 119.43,-49.67 118.73,-42.7\"/>\n<text text-anchor=\"middle\" x=\"167\" y=\"-48.3\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">broader</text>\n<polyline fill=\"none\" stroke=\"#00005a\" points=\"190.5,-44.5 143.5,-44.5 166,-41.53 \"/>\n</g>\n<!-- skill -->\n<g id=\"node5\" class=\"node\">\n<title>skill</title>\n<path fill=\"#92eb42\" stroke=\"#92eb42\" d=\"M65.33,-23C65.33,-23 43.67,-23 43.67,-23 39.83,-23 36,-19.17 36,-15.33 36,-15.33 36,-7.67 36,-7.67 36,-3.83 39.83,0 43.67,0 43.67,0 65.33,0 65.33,0 69.17,0 73,-3.83 73,-7.67 73,-7.67 73,-15.33 73,-15.33 73,-19.17 69.17,-23 65.33,-23\"/>\n<text text-anchor=\"middle\" x=\"54.5\" y=\"-7.8\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">skill</text>\n</g>\n<!-- ssyk&#45;level&#45;4&#45;&gt;skill -->\n<g id=\"edge4\" class=\"edge\">\n<title>ssyk&#45;level&#45;4&#45;&gt;skill</title>\n<path fill=\"none\" stroke=\"#00005a\" d=\"M229.19,-19.98C221.89,-18.17 214.26,-16.55 207,-15.5 164.33,-9.33 114.21,-9.42 83.66,-10.29\"/>\n<polygon fill=\"#00005a\" stroke=\"#00005a\" points=\"83.22,-6.8 73.34,-10.63 83.45,-13.79 83.22,-6.8\"/>\n<text text-anchor=\"middle\" x=\"167\" y=\"-19.3\" font-family=\"Arial\" font-size=\"14.00\" fill=\"#00005a\">broad_match</text>\n<polyline fill=\"none\" stroke=\"#00005a\" points=\"207,-15.5 127,-15.5 167.73,-11.52 \"/>\n</g>\n</g>\n</svg>\n"
               types-map)))))
